package de.lmu.ifi.dbs.elki.visualization;

/*
 This file is part of ELKI:
 Environment for Developing KDD-Applications Supported by Index-Structures

 Copyright (C) 2015
 Ludwig-Maximilians-Universität München
 Lehr- und Forschungseinheit für Datenbanksysteme
 ELKI Development Team

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU Affero General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Affero General Public License for more details.

 You should have received a copy of the GNU Affero General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Toggle action.
 *
 * @author Erich Schubert
 * @since 0.4.0
 */
public interface VisualizationMenuToggle extends VisualizationItem {
  /**
   * Menu item was activated.
   */
  void toggle();

  /**
   * Return the current state.
   *
   * @return {@code true} when selected.
   */
  boolean active();

  /**
   * Indicate if the menu option is enabled or greyed out.
   *
   * @return {@code true} when enabled.
   */
  boolean enabled();
}
